compact3
javax.naming

## Class CompoundName

- java.lang.Object
- - javax.naming.CompoundName

All Implemented Interfaces:
  Serializable, Cloneable, Comparable<Object>, Name

    public class CompoundName
    extends Object
    implements Name

This class represents a compound name -- a name from a hierarchical name space. Each component in a compound name is an atomic name.

The components of a compound name are numbered. The indexes of a compound name with N components range from 0 up to, but not including, N. This range may be written as [0,N). The most significant component is at index 0. An empty compound name has no components.

# Compound Name Syntax

The syntax of a compound name is specified using a set of properties:

jndi.syntax.direction
  Direction for parsing ("right_to_left", "left_to_right", "flat"). If unspecified, defaults to "flat", which means the namespace is flat with no hierarchical structure.
jndi.syntax.separator
  Separator between atomic name components. Required unless direction is "flat".
jndi.syntax.ignorecase
  If present, "true" means ignore the case when comparing name components. If its value is not "true", or if the property is not present, case is considered when comparing name components.
jndi.syntax.escape
  If present, specifies the escape string for overriding separator, escapes and quotes.
jndi.syntax.beginquote
  If present, specifies the string delimiting start of a quoted string.
jndi.syntax.endquote
  String delimiting end of quoted string. If present, specifies the string delimiting the end of a quoted string. If not present, use syntax.beginquote as end quote.
jndi.syntax.beginquote2
  Alternative set of begin/end quotes.
jndi.syntax.endquote2
  Alternative set of begin/end quotes.
jndi.syntax.trimblanks
  If present, "true" means trim any leading and trailing whitespaces in a name component for comparison purposes. If its value is not "true", or if the property is not present, blanks are significant.
jndi.syntax.separator.ava
  If present, specifies the string that separates attribute-value-assertions when specifying multiple attribute/value pairs. (e.g. "," in age=65,gender=male).
jndi.syntax.separator.typeval
  If present, specifies the string that separators attribute from value (e.g. "=" in "age=65")

These properties are interpreted according to the following rules:

1. In a string without quotes or escapes, any instance of the separator delimits two atomic names. Each atomic name is referred to as a component.
2. A separator, quote or escape is escaped if preceded immediately (on the left) by the escape.
3. If there are two sets of quotes, a specific begin-quote must be matched by its corresponding end-quote.
4. A non-escaped begin-quote which precedes a component must be matched by a non-escaped end-quote at the end of the component. A component thus quoted is referred to as a quoted component. It is parsed by removing the being- and end- quotes, and by treating the intervening characters as ordinary characters unless one of the rules involving quoted components listed below applies.
5. Quotes embedded in non-quoted components are treated as ordinary strings and need not be matched.
6. A separator that is escaped or appears between non-escaped quotes is treated as an ordinary string and not a separator.
7. An escape string within a quoted component acts as an escape only when followed by the corresponding end-quote string. This can be used to embed an escaped quote within a quoted component.
8. An escaped escape string is not treated as an escape string.
9. An escape string that does not precede a meta string (quotes or separator) and is not at the end of a component is treated as an ordinary string.
10. A leading separator (the compound name string begins with a separator) denotes a leading empty atomic component (consisting of an empty string). A trailing separator (the compound name string ends with a separator) denotes a trailing empty atomic component. Adjacent separators denote an empty atomic component.

The string form of the compound name follows the syntax described above. When the components of the compound name are turned into their string representation, the reserved syntax rules described above are applied (e.g. embedded separators are escaped or quoted) so that when the same string is parsed, it will yield the same components of the original compound name.

# Multithreaded Access

A `CompoundName` instance is not synchronized against concurrent multithreaded access. Multiple threads trying to access and modify a `CompoundName` should lock the object.

Since:
  1.3
See Also:
  Serialized Form

### Field Summary

Fields
`protected javax.naming.NameImpl` `impl` Implementation of this compound name.
`protected Properties` `mySyntax` Syntax properties for this compound name.

### Constructor Summary

Constructors
`protected` `CompoundName(Enumeration<String> comps, Properties syntax)` Constructs a new compound name instance using the components specified in comps and syntax.
`` `CompoundName(String n, Properties syntax)` Constructs a new compound name instance by parsing the string n using the syntax specified by the syntax properties supplied.

### Method Summary

All Methods Instance Methods Concrete Methods
`Name` `add(int posn, String comp)` Adds a single component at a specified position within this compound name.
`Name` `add(String comp)` Adds a single component to the end of this compound name.
`Name` `addAll(int posn, Name n)` Adds the components of a compound name -- in order -- at a specified position within this compound name.
`Name` `addAll(Name suffix)` Adds the components of a compound name -- in order -- to the end of this compound name.
`Object` `clone()` Creates a copy of this compound name.
`int` `compareTo(Object obj)` Compares this CompoundName with the specified Object for order.
`boolean` `endsWith(Name n)` Determines whether a compound name is a suffix of this compound name.
`boolean` `equals(Object obj)` Determines whether obj is syntactically equal to this compound name.
`String` `get(int posn)` Retrieves a component of this compound name.
`Enumeration<String>` `getAll()` Retrieves the components of this compound name as an enumeration of strings.
`Name` `getPrefix(int posn)` Creates a compound name whose components consist of a prefix of the components in this compound name.
`Name` `getSuffix(int posn)` Creates a compound name whose components consist of a suffix of the components in this compound name.
`int` `hashCode()` Computes the hash code of this compound name.
`boolean` `isEmpty()` Determines whether this compound name is empty.
`Object` `remove(int posn)` Deletes a component from this compound name.
`int` `size()` Retrieves the number of components in this compound name.
`boolean` `startsWith(Name n)` Determines whether a compound name is a prefix of this compound name.
`String` `toString()` Generates the string representation of this compound name, using the syntax rules of the compound name.

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### impl

    protected transient javax.naming.NameImpl impl

Implementation of this compound name. This field is initialized by the constructors and cannot be null. It should be treated as a read-only variable by subclasses.

#### mySyntax

    protected transient Properties mySyntax

Syntax properties for this compound name. This field is initialized by the constructors and cannot be null. It should be treated as a read-only variable by subclasses. Any necessary changes to mySyntax should be made within constructors and not after the compound name has been instantiated.

### Constructor Detail

#### CompoundName

    protected CompoundName(Enumeration<String> comps,
                           Properties syntax)

Constructs a new compound name instance using the components specified in comps and syntax. This protected method is intended to be to be used by subclasses of CompoundName when they override methods such as clone(), getPrefix(), getSuffix().

Parameters:
  `comps` - A non-null enumeration of the components to add. Each element of the enumeration is of class String. The enumeration will be consumed to extract its elements.
  `syntax` - A non-null properties that specify the syntax of this compound name. See class description for contents of properties.

#### CompoundName

    public CompoundName(String n,
                        Properties syntax)
                 throws InvalidNameException

Constructs a new compound name instance by parsing the string n using the syntax specified by the syntax properties supplied.

Parameters:
  `n` - The non-null string to parse.
  `syntax` - A non-null list of properties that specify the syntax of this compound name. See class description for contents of properties.
Throws:
  `InvalidNameException` - If 'n' violates the syntax specified by `syntax`.

### Method Detail

#### toString

    public String toString()

Generates the string representation of this compound name, using the syntax rules of the compound name. The syntax rules are described in the class description. An empty component is represented by an empty string. The string representation thus generated can be passed to the CompoundName constructor with the same syntax properties to create a new equivalent compound name.

Overrides:
  `toString` in class `Object`
Returns:
  A non-null string representation of this compound name.

#### equals

    public boolean equals(Object obj)

Determines whether obj is syntactically equal to this compound name. If obj is null or not a CompoundName, false is returned. Two compound names are equal if each component in one is "equal" to the corresponding component in the other.

Equality is also defined in terms of the syntax of this compound name. The default implementation of CompoundName uses the syntax properties jndi.syntax.ignorecase and jndi.syntax.trimblanks when comparing two components for equality. If case is ignored, two strings with the same sequence of characters but with different cases are considered equal. If blanks are being trimmed, leading and trailing blanks are ignored for the purpose of the comparison.

Both compound names must have the same number of components.

Implementation note: Currently the syntax properties of the two compound names are not compared for equality. They might be in the future.

Overrides:
  `equals` in class `Object`
Parameters:
  `obj` - The possibly null object to compare against.
Returns:
  true if obj is equal to this compound name, false otherwise.
See Also:
  `compareTo(java.lang.Object obj)`

#### hashCode

    public int hashCode()

Computes the hash code of this compound name. The hash code is the sum of the hash codes of the "canonicalized" forms of individual components of this compound name. Each component is "canonicalized" according to the compound name's syntax before its hash code is computed. For a case-insensitive name, for example, the uppercased form of a name has the same hash code as its lowercased equivalent.

Overrides:
  `hashCode` in class `Object`
Returns:
  An int representing the hash code of this name.
See Also:
  `Object.equals(java.lang.Object)`, `System.identityHashCode(java.lang.Object)`

#### clone

    public Object clone()

Creates a copy of this compound name. Changes to the components of this compound name won't affect the new copy and vice versa. The clone and this compound name share the same syntax.

Specified by:
  `clone` in interface `Name`
Overrides:
  `clone` in class `Object`
Returns:
  A non-null copy of this compound name.
See Also:
  `Cloneable`

#### compareTo

    public int compareTo(Object obj)

Compares this CompoundName with the specified Object for order. Returns a negative integer, zero, or a positive integer as this Name is less than, equal to, or greater than the given Object.

If obj is null or not an instance of CompoundName, ClassCastException is thrown.

See equals() for what it means for two compound names to be equal. If two compound names are equal, 0 is returned.

Ordering of compound names depend on the syntax of the compound name. By default, they follow lexicographical rules for string comparison with the extension that this applies to all the components in the compound name and that comparison of individual components is affected by the jndi.syntax.ignorecase and jndi.syntax.trimblanks properties, identical to how they affect equals(). If this compound name is "lexicographically" lesser than obj, a negative number is returned. If this compound name is "lexicographically" greater than obj, a positive number is returned.

Implementation note: Currently the syntax properties of the two compound names are not compared when checking order. They might be in the future.

Specified by:
  `compareTo` in interface `Comparable<Object>`
Specified by:
  `compareTo` in interface `Name`
Parameters:
  `obj` - The non-null object to compare against.
Returns:
  a negative integer, zero, or a positive integer as this Name is less than, equal to, or greater than the given Object.
Throws:
  `ClassCastException` - if obj is not a CompoundName.
See Also:
  `equals(java.lang.Object)`

#### size

    public int size()

Retrieves the number of components in this compound name.

Specified by:
  `size` in interface `Name`
Returns:
  The nonnegative number of components in this compound name.

#### isEmpty

    public boolean isEmpty()

Determines whether this compound name is empty. A compound name is empty if it has zero components.

Specified by:
  `isEmpty` in interface `Name`
Returns:
  true if this compound name is empty, false otherwise.

#### getAll

    public Enumeration<String> getAll()

Retrieves the components of this compound name as an enumeration of strings. The effects of updates to this compound name on this enumeration is undefined.

Specified by:
  `getAll` in interface `Name`
Returns:
  A non-null enumeration of the components of this compound name. Each element of the enumeration is of class String.

#### get

    public String get(int posn)

Retrieves a component of this compound name.

Specified by:
  `get` in interface `Name`
Parameters:
  `posn` - The 0-based index of the component to retrieve. Must be in the range [0,size()).
Returns:
  The component at index posn.
Throws:
  `ArrayIndexOutOfBoundsException` - if posn is outside the specified range.

#### getPrefix

    public Name getPrefix(int posn)

Creates a compound name whose components consist of a prefix of the components in this compound name. The result and this compound name share the same syntax. Subsequent changes to this compound name does not affect the name that is returned and vice versa.

Specified by:
  `getPrefix` in interface `Name`
Parameters:
  `posn` - The 0-based index of the component at which to stop. Must be in the range [0,size()].
Returns:
  A compound name consisting of the components at indexes in the range [0,posn).
Throws:
  `ArrayIndexOutOfBoundsException` - If posn is outside the specified range.

#### getSuffix

    public Name getSuffix(int posn)

Creates a compound name whose components consist of a suffix of the components in this compound name. The result and this compound name share the same syntax. Subsequent changes to this compound name does not affect the name that is returned.

Specified by:
  `getSuffix` in interface `Name`
Parameters:
  `posn` - The 0-based index of the component at which to start. Must be in the range [0,size()].
Returns:
  A compound name consisting of the components at indexes in the range [posn,size()). If posn is equal to size(), an empty compound name is returned.
Throws:
  `ArrayIndexOutOfBoundsException` - If posn is outside the specified range.

#### startsWith

    public boolean startsWith(Name n)

Determines whether a compound name is a prefix of this compound name. A compound name 'n' is a prefix if it is equal to getPrefix(n.size())--in other words, this compound name starts with 'n'. If n is null or not a compound name, false is returned.

Implementation note: Currently the syntax properties of n are not used when doing the comparison. They might be in the future.

Specified by:
  `startsWith` in interface `Name`
Parameters:
  `n` - The possibly null compound name to check.
Returns:
  true if n is a CompoundName and is a prefix of this compound name, false otherwise.

#### endsWith

    public boolean endsWith(Name n)

Determines whether a compound name is a suffix of this compound name. A compound name 'n' is a suffix if it it is equal to getSuffix(size()-n.size())--in other words, this compound name ends with 'n'. If n is null or not a compound name, false is returned.

Implementation note: Currently the syntax properties of n are not used when doing the comparison. They might be in the future.

Specified by:
  `endsWith` in interface `Name`
Parameters:
  `n` - The possibly null compound name to check.
Returns:
  true if n is a CompoundName and is a suffix of this compound name, false otherwise.

#### addAll

    public Name addAll(Name suffix)
                throws InvalidNameException

Adds the components of a compound name -- in order -- to the end of this compound name.

Implementation note: Currently the syntax properties of suffix is not used or checked. They might be in the future.

Specified by:
  `addAll` in interface `Name`
Parameters:
  `suffix` - The non-null components to add.
Returns:
  The updated CompoundName, not a new one. Cannot be null.
Throws:
  `InvalidNameException` - If suffix is not a compound name, or if the addition of the components violates the syntax of this compound name (e.g. exceeding number of components).

#### addAll

    public Name addAll(int posn,
                       Name n)
                throws InvalidNameException

Adds the components of a compound name -- in order -- at a specified position within this compound name. Components of this compound name at or after the index of the first new component are shifted up (away from index 0) to accommodate the new components.

Implementation note: Currently the syntax properties of suffix is not used or checked. They might be in the future.

Specified by:
  `addAll` in interface `Name`
Parameters:
  `n` - The non-null components to add.
  `posn` - The index in this name at which to add the new components. Must be in the range [0,size()].
Returns:
  The updated CompoundName, not a new one. Cannot be null.
Throws:
  `ArrayIndexOutOfBoundsException` - If posn is outside the specified range.
  `InvalidNameException` - If n is not a compound name, or if the addition of the components violates the syntax of this compound name (e.g. exceeding number of components).

#### add

    public Name add(String comp)
             throws InvalidNameException

Adds a single component to the end of this compound name.

Specified by:
  `add` in interface `Name`
Parameters:
  `comp` - The non-null component to add.
Returns:
  The updated CompoundName, not a new one. Cannot be null.
Throws:
  `InvalidNameException` - If adding comp at end of the name would violate the compound name's syntax.

#### add

    public Name add(int posn,
                    String comp)
             throws InvalidNameException

Adds a single component at a specified position within this compound name. Components of this compound name at or after the index of the new component are shifted up by one (away from index 0) to accommodate the new component.

Specified by:
  `add` in interface `Name`
Parameters:
  `comp` - The non-null component to add.
  `posn` - The index at which to add the new component. Must be in the range [0,size()].
Returns:
  The updated CompoundName, not a new one. Cannot be null.
Throws:
  `ArrayIndexOutOfBoundsException` - If posn is outside the specified range.
  `InvalidNameException` - If adding comp at the specified position would violate the compound name's syntax.

#### remove

    public Object remove(int posn)
                  throws InvalidNameException

Deletes a component from this compound name. The component of this compound name at position 'posn' is removed, and components at indices greater than 'posn' are shifted down (towards index 0) by one.

Specified by:
  `remove` in interface `Name`
Parameters:
  `posn` - The index of the component to delete. Must be in the range [0,size()).
Returns:
  The component removed (a String).
Throws:
  `ArrayIndexOutOfBoundsException` - If posn is outside the specified range (includes case where compound name is empty).
  `InvalidNameException` - If deleting the component would violate the compound name's syntax.